unit main;

// SIPInside, Delphi SoftPhone for freephonie.net (c)2006 by Paul TOTH <tothpaul@free.fr>
// http://tothpaul.free.fr

{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

{-$DEFINE CONSOLE} // debug SIP protocol

{
 version 0.2.3
  - ajout des paramtres -p -i et -o

 version 0.2.2
  - cration des raccourcis

 version 0.2.1
  - ajout de STUN pour dterminer l'adresse IP publique
  - dtection des priphriques audio par dfaut
  - rafraichissement des listes de priphriques (WM_DEVICECHANGE)
  - suppression de l'aide en ligne pour passer en dessous des 500Ko :D

 version 0.2
  - premire release des sources
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, MMSystem,
  Dialogs, StdCtrls, ExtCtrls, ShellAPI, Winsock, SHLObj, ComObj, ActiveX, SIP, RTP, RTCP, g711a, STUN;

type
  TMainForm = class(TForm)
    SIPInside: TLabel;
    TelephoneIP: TLabel;
    Title: TLabel;
    ConnexionPanel: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    UserID: TEdit;
    Password: TEdit;
    Domain: TEdit;
    Shape1: TShape;
    Connect: TLabel;
    PaulToth: TLabel;
    MyAccount: TLabel;
    ShapeAccount: TShape;
    Line: TLabel;
    WaitPanel: TPanel;
    Status: TLabel;
    Shape2: TShape;
    Cancel: TLabel;
    Label11: TLabel;
    Username: TEdit;
    Label10: TLabel;
    PhoneNumber: TEdit;
    Label12: TLabel;
    WaveOutList: TComboBox;
    Label13: TLabel;
    WaveInList: TComboBox;
    n1: TLabel;
    n2: TLabel;
    n3: TLabel;
    n6: TLabel;
    n4: TLabel;
    n5: TLabel;
    n9: TLabel;
    n7: TLabel;
    n8: TLabel;
    nSharp: TLabel;
    nStar: TLabel;
    n0: TLabel;
    Beta: TLabel;
    na: TLabel;
    nb: TLabel;
    nc: TLabel;
    nd: TLabel;
    PaintBox1: TPaintBox;
    lbAddr: TLabel;
    Addr: TEdit;
    SaveDlg: TSaveDialog;
    Image1: TImage;
    procedure MyAccountClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ConnectClick(Sender: TObject);
    procedure CancelClick(Sender: TObject);
    procedure EditKeyPress(Sender: TObject; var Key: Char);
    procedure n1MouseEnter(Sender: TObject);
    procedure n1MouseLeave(Sender: TObject);
    procedure WaveOutListChange(Sender: TObject);
    procedure nSharpClick(Sender: TObject);
    procedure n1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure n1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure WaveInListChange(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure PaulTothClick(Sender: TObject);
    procedure Image1Click(Sender: TObject);
  private
    { Private declarations }
    SIP :TSIPClient;  // SIP protocol
    RTP :TRTPClient;  // RTP protocol
    RTCP:TRTCPClient; // RTCP protocol
    PCMA:TPCMA;       // g711a codes
    STUN:TSTUNClient;
    procedure CheckDevices;
    procedure SetWaveIn(const Name:string);
    procedure SetWaveOut(const Name:string);
    procedure WMSIPMessage(var Msg); message WM_USER+1; // SIP Callback message
    procedure WMSTUNMessage(var Msg); message WM_USER+2; // STUN Callback message
    procedure WAVEInData(Var Msg:TMessage); message MM_WIM_DATA; // waveIn callback message
    procedure WMDeviceChange(Var Msg:TMessage); message WM_DEVICECHANGE;
    procedure OnError(Sender:TObject);
   {$IFDEF CONSOLE}
    procedure OnSend(Sender:TObject);
    procedure OnRecv(Sender:TObject);
   {$ENDIF}
    procedure OnStep(Sender:TObject);
    procedure OnClose(Sender:TObject);
    procedure OnStart(Sender:TObject);
    procedure OnBind(Sender:TObject);
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

procedure TMainForm.FormCreate(Sender: TObject);
var
 i:integer;
 s,p:string;
begin
 Caption:=SIP_RELEASE+' - Un client SIP pour Freenaute';

 SIP:=TSIPClient.Create(Handle,WM_USER+1); // ASync socket
 SIP.OnError:=OnError;
{$IFDEF CONSOLE}
 SIP.OnSend:=OnSend;
 SIP.OnRecv:=OnRecv;
{$ENDIF}
 SIP.OnStep:=OnStep;
 SIP.OnClose:=OnClose;
 SIP.OnStart:=OnStart;

 RTP :=TRTPClient.Create;
 RTCP:=TRTCPClient.Create(RTP);
 PCMA:=TPCMA.Create(Handle); // Handle needed for waveIn callback message

 Addr.Text:=RTP.LocalAddr;
 SIP.SetLocal(RTP.LocalAddr,RTP.Port);

 STUN:=TSTUNClient.Create(Handle,WM_USER+2);
 STUN.OnBind:=OnBind;
 STUN.Request('stun.fwdnet.net');

 CheckDevices;

// save current label (see Cancel.Click)
 Status.Hint:=Status.Caption;
 Cancel.Hint:=Cancel.Caption;

 // "UserName" <userid:password@domain>
 if ParamCount>0 then begin
  UserName.Text:=ParamStr(1);
  if ParamCount=3 then begin // version 0.2.2
   PhoneNumber.Text:=ParamStr(3);
  end else begin // version 0.2.3
   i:=3;
   while i<ParamCount do begin
    s:=ParamStr(i); inc(i);
    if (Length(s)=2)and(s[1]='-') then begin
     p:=ParamStr(i); inc(i);
     case s[2] of
      'p': PhoneNumber.Text:=p;
      'i': SetWaveIn(p);
      'o': SetWaveOut(p);
     end;
    end;
   end;
  end;
  s:=ParamStr(2);
  if s='' then exit;
  if (s[1]<>'<')or(s[length(s)]<>'>') then exit;
  s:=copy(s,2,length(s)-2);
  if copy(s,1,4)='sip:' then delete(s,1,4);
  i:=pos(':',s);
  if i>0 then begin
   UserId.Text:=copy(s,1,i-1);
   Delete(s,1,i);
   i:=pos('@',s);
   if i=0 then exit;
   Password.Text:=copy(s,1,i-1);
   Domain.Text:=copy(s,i+1,MaxInt);
   ActiveControl:=PhoneNumber;
  end else begin
   i:=pos('@',s);
   if i=0 then exit;
   UserId.Text:=copy(s,1,i-1);
   Domain.Text:=copy(s,i+1,MaxInt);
   ActiveControl:=Password;
  end;
 end;

end;

procedure TMainForm.WaveOutListChange(Sender: TObject);
begin
 PCMA.DevOut:=WaveOutList.ItemIndex;
end;

procedure TMainForm.WaveInListChange(Sender: TObject);
begin
 PCMA.DevIn:=WaveInList.ItemIndex;
end;

procedure TMainForm.WMDeviceChange(Var Msg:TMessage);
begin
// ne pas rafraichir la liste en cours de conversation
 if ConnexionPanel.Visible then CheckDevices else ConnexionPanel.Tag:=1;
end;

procedure TMainForm.CheckDevices;
var
 Handle:HKEY;
 RegType:integer;
 DataSize:integer;
 smPlayback:string;
 smRecord  :string;
 i,count:integer;
 info:TWaveOutCaps;
 list:TStringList;
 ok:boolean;
begin
// priphriques par dfaut
 if (RegOpenKeyEx(HKEY_CURRENT_USER,'Software\Microsoft\Multimedia\Sound Mapper',0,KEY_ALL_ACCESS,Handle)=ERROR_SUCCESS) then begin
  if RegQueryValueEx(Handle,'Playback',nil,@RegType,nil,@DataSize)=ERROR_SUCCESS then begin
   SetLength(smPlayback,Datasize);
   RegQueryValueEx(Handle,'Playback',nil,@RegType,PByte(@smPlayback[1]),@DataSize);
   SetLength(smPlayback,Datasize-1);
  end;
  if RegQueryValueEx(Handle,'Record',nil,@RegType,nil,@DataSize)=ERROR_SUCCESS then begin
   SetLength(smRecord,Datasize);
   RegQueryValueEx(Handle,'Record',nil,@RegType,PByte(@smRecord[1]),@DataSize);
   SetLength(smRecord,Datasize-1);
  end;
  RegCloseKey(Handle);
 end;
//
 ok:=True;
 list:=TStringList.Create;
 try
 // waveOut devices
  count:=waveOutGetNumDevs();
  for i:=0 to count-1 do begin
   if waveOutGetDevCaps(i, @info, SizeOf(Info))=0 then begin
    list.Add(info.szPname);
   end;
  end;

  if List.Count=0 then begin
   ok:=False;
   WaveOutList.Items.Clear;
   PCMA.DevOut:=-1;
  end else begin
   i:=WaveOutList.ItemIndex;
   WaveOutList.Items.Assign(List);
   if i<0 then i:=List.IndexOf(smPlayback);
   if (i<0)or(i>=List.Count) then i:=0;
   WaveOutlist.ItemIndex:=i;
   PCMA.DevOut:=i;
   List.Clear;
  end;

 // waveIn devices
  count:=waveInGetNumDevs();
  for i:=0 to count-1 do begin
   if waveInGetDevCaps(i, @info, SizeOf(Info))=0 then begin
    List.Add(info.szPname);
   end;
  end;

  if List.Count=0 then begin
   ok:=False;
   WaveInList.Items.Clear;
   PCMA.DevIn:=-1;
  end else begin
   i:=WaveInList.ItemIndex;
   if i<0 then i:=List.IndexOf(smRecord);
   WaveInList.Items.Assign(List);
   if (i<0)or(i>=List.Count) then i:=0;
   WaveInlist.ItemIndex:=i;
   PCMA.DevIn:=i;
   List.Clear;
  end;

 finally
  List.Free;
 end;

 Connect.Enabled:=ok;
 if ok then
  Shape1.Brush.Color:=$1600DB
 else
  Shape1.Brush.Color:=clSilver;
end;

procedure TMainForm.SetWaveIn(const Name:string);
var
 i:integer;
begin
 if Name='' then exit;
 i:=WaveInList.Items.IndexOf(Name);
 if i<0 then exit;
 WaveInList.ItemIndex:=i;
 PCMA.DevIn:=i;
end;

procedure TMainForm.SetWaveOut(const Name:string);
var
 i:integer;
begin
 if Name='' then exit;
 i:=WaveOutList.Items.IndexOf(Name);
 if i<0 then exit;
 WaveOutList.ItemIndex:=i;
 PCMA.DevOut:=i;
end;

procedure TMainForm.MyAccountClick(Sender: TObject);
begin
 ShellExecute(0,nil,'http://subscribe.free.fr/login/',nil,nil,SW_SHOW);
end;

procedure TMainForm.PaulTothClick(Sender: TObject);
begin
 ShellExecute(0,nil,'http://tothpaul.free.fr/',nil,nil,SW_SHOW);
end;

procedure TMainForm.ConnectClick(Sender: TObject);
begin
 if Username.Text='' then begin
  ShowMessage('Veuillez indiquer votre pseudo');
  Username.SetFocus();
  exit;
 end;
 if UserId.Text='' then begin
  ShowMessage('Veuillez indiquer votre identifiant SIP (08 7x xx xx xx)');
  UserId.SetFocus();
  exit;
 end;
 if Password.Text='' then begin
  ShowMessage('Veuillez indiquer votre mot de passe SIP');
  Password.SetFocus();
  exit;
 end;
 if Domain.Text='' then begin
  ShowMessage('Veuillez indiquer votre domaine SIP (freephonie.net)');
  Domain.SetFocus();
  exit;
 end;
 if PhoneNumber.Text='' then begin
  ShowMessage('Veuillez indiquer le numro de tlphone de votre correspondant');
  PhoneNumber.SetFocus();
  exit;
 end;
 ConnexionPanel.Hide;
 Status.Caption:=Status.Hint;
 Cancel.Caption:=Cancel.Hint;
 Cancel.Tag:=0;
 WaitPanel.Show;
 SIP.Call(Username.Text,Domain.Text,UserID.Text,Password.Text,PhoneNumber.Text);
end;

procedure TMainForm.CancelClick(Sender: TObject);
begin
 if Cancel.Tag=0 then begin
 {$IFDEF CONSOLE}
  AllocConsole;
  WriteLn('SIP.Cancel');
 {$ENDIF}
  SIP.Cancel;
 {$IFDEF CONSOLE}
  WriteLn('RTCP.Leave');
 {$ENDIF}
  RTCP.Leave;
 {$IFDEF CONSOLE}
  WriteLn('PCMA.Close');
 {$ENDIF}
  PCMA.Close;
 {$IFDEF CONSOLE}
  WriteLn('Done');
 {$ENDIF}
 end else begin
  WaitPanel.Hide;
  ConnexionPanel.Show;
  if ConnexionPanel.Tag=1 then begin
   ConnexionPanel.Tag:=0;
   CheckDevices;
  end;
 end;
end;

procedure TMainForm.EditKeyPress(Sender: TObject; var Key: Char);
begin
 if Key=#13 then begin
  Key:=#0;
  ConnectClick(Self);
 end else begin
  if (TEdit(Sender).Tag=1)and(not (Key in [#8,'0'..'9'])) then Key:=#0;
 end;
end;

procedure TMainForm.OnError(Sender:TObject);
begin
 case SIP.Error of
  SIP_HOST_NOT_FOUND  : ShowMessage('Domain introuvable : '+SIP.Domain);
  SIP_NO_SOCKET       : ShowMessage('Problme d''ouverture de socket');
  SIP_SEND_ERROR      : ShowMessage('Erreur d''criture');
  SIP_RECV_ERROR      : ShowMessage('Erreur de lecture');
  SIP_INVALID_RESPONSE: ShowMessage('Rponse invalide'#13+SIP.Head);
  SIP_UNAUTHORIZED    : ShowMessage('Accs refus');
  SIP_NOT_CONNECTED   : ShowMessage('Opration hors contexte');
  else ShowMessage('SIP Error #'+IntToStr(SIP.Error));
 end;
end;

{$IFDEF CONSOLE}
procedure TMainForm.OnSend(Sender:TObject);
begin
 AllocConsole;
 WriteLn('<--SEND-->');
 WriteLn(SIP.Send);
end;

procedure TMainForm.OnRecv(Sender:TObject);
begin
 AllocConsole;
 WriteLn('<--RECV-->');
 WriteLn(SIP.Head);
 Write('<---');
 Write(SIP.Data);
 WriteLn('--->');
end;
{$ENDIF}

procedure TMainForm.OnStep(Sender:TObject);
begin
 case SIP.Step of
  csNONE    : Status.Caption:='hors ligne';
  csINVITE  : Status.Caption:='attente du serveur...';
  csTRYING  : Status.Caption:='appel en cours...';
  csRINGING : Status.Caption:='a sonne...';
  csCANCEL  : Status.Caption:='on abandonne...';
  csCANCELED: Status.Caption:='l''appel n''a pas abouti';
  csONLINE  : Status.Caption:='en ligne !';
  csSENDBYE : Status.Caption:='on raccroche...';
  csRECVBYE : Status.Caption:='votre correspond a raccroch';
  csWRONG   : Status.Caption:='Identifiant ou mot de passe invalide !';
 end;
 if SIP.Step=csONLINE then WaitPanel.Height:=225 else WaitPanel.Height:=113;
end;

procedure TMainForm.OnClose(Sender:TObject);
begin
 RTCP.Leave;
 PCMA.Close;
 Cancel.Tag:=1;
 Cancel.Caption:='Fermer';
end;

procedure TMainForm.OnStart(Sender:TObject);
var
 s:string;
 i:integer;
 p:integer;
begin
 s:=SIP.RemoteSDP;
// quick check for Freephonie.net only ! don't expect that to work with any SIP server !!!
// port
 i:=pos('m=audio ',s);
 if i=0 then exit;
 s:=copy(s,i+8,MaxInt);
 val(s,p,i);
// ip
 s:=SIP.RemoteSDP;
 i:=pos('c=IN IP4 ',s);
 if i=0 then exit;
 s:=copy(s,i+9,MaxInt);
 i:=pos(#13,s);
 SetLength(s,i-1);
 RTCP.Start(s,p);   // create sockets
 PCMA.Listen(RTCP); // start waveIn/waveOut
 RTCP.Enter;        // send initial RTP Payload
end;

procedure TMainForm.OnBind(Sender:TObject);
var
 s:string;
begin
 s:=inet_ntoa(in_addr(STUN.Address));
 if Addr.Text<>s then begin
  Addr.Text:=s;
  lbAddr.Caption:='Votre adresse IP publique :';
  lbAddr.Show;
  Addr.Show;
  SIP.SetLocal(s,RTP.Port);
 end;
end;

procedure TMainForm.WMSIPMessage(var Msg);
begin
 SIP.ProcessMessage(Msg); // Async socket callback
end;

procedure TMainForm.WMSTUNMessage(var Msg);
begin
 STUN.ProcessMessage(Msg); 
end;

procedure TMainForm.WAVEInData(Var Msg:TMessage);
// waveIn callback
var
 Header:PWaveHdr;
      s:^smallint;
      i:integer;
    amp:integer;
 absamp:integer;
 maxamp:integer;
begin
 Header:=pointer(Msg.LParam);
 with PaintBox1.Canvas do begin
  Brush.Color:=clBlack;
  Pen.color:=clBlack;
  Rectangle(0,0,480,100);
  Pen.Color:=clLime;
  MoveTo(0,25);
  s:=pointer(Header.lpData);
  maxamp:=0;
  for i:=0 to 239 do begin
   amp:=round(50*s^/$7fff);
   LineTo(i,25+amp);
   absamp:=abs(amp);
   if absamp>maxamp then maxamp:=absamp;
   inc(s);
  end;
 end;
// enought amplitude ?
 if maxamp>1 then
 // send buffer to the remote client
  PCMA.WaveInMessage(Msg.wParam,Header)
 else
 // just add the buffer to the listen queue
  waveInAddBuffer(Msg.wParam,Header,SizeOf(TWaveHdr));
end;

procedure TMainForm.n1MouseEnter(Sender: TObject);
begin
// keypad color when mouse is over
 TLabel(Sender).Color:=clRed;
end;

procedure TMainForm.n1MouseLeave(Sender: TObject);
begin
// keypad color when mouse leave (or is not over)
 TLabel(Sender).Color:=$001600DB;
end;

procedure TMainForm.nSharpClick(Sender: TObject);
begin
// play/send DTMF
 PCMA.SendDTMF(TLabel(Sender).Tag);
end;

procedure TMainForm.n1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
// keypad color when clicked
 TLabel(Sender).Color:=clYellow;
end;

procedure TMainForm.n1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
// keypad color when click is done
 TLabel(Sender).Color:=clRed;
end;

procedure TMainForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
 if SIP.Step<>csONLINE then exit;
 case Key of
  '0'..'9': PCMA.SendDTMF(Ord(Key)-Ord('0'));
  '*'     : PCMA.SendDTMF(10);
  '#','.' : PCMA.SendDTMF(11);
  'a'..'d': PCMA.SendDTMF(Ord(Key)-Ord('a')+12);
  'A'..'D': PCMA.SendDTMF(Ord(Key)-Ord('A')+12);
 end;
end;

procedure TMainForm.Image1Click(Sender: TObject);
var
 Path:array[0..MAX_PATH] of char;
 IdList:PITEMIDLIST;
 ShellLink:IShellLink;
 PersistFile:IPersistFile;
 WS:WideString;
 parms:string;
begin
 if SHGetSpecialFolderLocation(0,CSIDL_DESKTOPDIRECTORY, IdList)= NOERROR then begin
  SHGetPathFromIDList(IdList, Path);
  SaveDlg.FileName:=Path+'\SIPInside ('+UserName.Text+').lnk';
 end;
 if SaveDlg.Execute then begin
  parms:='';
  if (UserId.Text<>'')and(Domain.Text<>'') then begin
   parms:='"'+UserName.Text+'" <'+UserID.text;
   if (Password.Text<>'') then parms:=parms+':{'+SIP.Crunch(UserID.Text,Domain.Text,Password.Text)+'}';
   parms:=parms+'@'+Domain.Text+'>';
  end;
  if PhoneNumber.Text<>'' then parms:=parms+' -p "'+PhoneNumber.Text+'"';
  if WaveInList.ItemIndex>=0 then parms:=parms+' -i "'+WaveInList.Items[WaveInList.ItemIndex]+'"';
  if WaveOutList.ItemIndex>=0 then parms:=parms+' -o "'+WaveOutList.Items[WaveOutList.ItemIndex]+'"';
  ShellLink:=CreateComObject(CLSID_ShellLink) as IShellLink;
  PersistFile:=(ShellLink as IPersistFile);
  WS:=StringToOleStr(SaveDlg.FileName);
  if FileExists(SaveDlg.FileName) then begin
   if PersistFile.Load(@WS[1],STGM_READWRITE or STGM_SHARE_EXCLUSIVE)<>0 then begin
    MessageBox(Handle,'Impossible de modifier le raccourci, merci de le supprimer manuellement','Attention',MB_ICONWARNING);
    exit;
   end;
   ShellLink.Resolve(0,SLR_ANY_MATCH or SLR_UPDATE or SLR_NO_UI);
   WriteLn(Windows.DeleteFile(pchar(SaveDlg.FileName)));
  end else begin
   ShellLink.SetPath(PChar(Application.ExeName));
   ShellLink.SetShowCmd(SW_SHOW);
  end;
  ShellLink.SetArguments(pchar(parms));
  PersistFile.Save(@WS[1], true);
 end;
end;

end.

